VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "Sheet1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = True
Private Sub CommandButton1_Click()                                              '1
 
Dim vi       As Long                                                            '3
Dim ret      As Long
Dim msg      As String
Dim err_msg  As String * 256                                                    '6
 
'Starting the session *******************************************
ret = age5270_init("GPIB::17::INSTR", VI_TRUE, VI_TRUE, vi)                     '9
If ((vi = VI_NULL) Or (ret < VI_SUCCESS)) Then                                 '10
  msg = "Initialization failure." & Chr(10) & Chr(10) & "Status Code:  " & ret
  MsgBox msg, vbOKOnly, ""
  If (vi <> VI_NULL) Then
    ret = age5270_error_message(vi, ret, err_msg)
    msg = "Error:  " & ret & Chr(10) & Chr(10) & err_msg
    MsgBox msg, vbOKOnly, ""
  End If
  End
End If                                                                         '19
 
ret = age5270_reset(vi)                      'Resets E5270.                    '21
ret = age5270_timeOut(vi, 60000)             'Sets time out to 60 sec.
ret = age5270_errorQueryDetect(vi, VI_TRUE)  'Enables error detection.

perform_meas vi, ret                  'Calls perform_meas subprogram.           25
'ret = age5270_cmd(vi, "aa")           'Sends invalid command.
'check_err vi, ret                     'Checks check_err subprogram operation.
 
'Closing the session ********************************************
ret = age5270_close(vi)                                                        '30
check_err vi, ret
 
msg = "Press OK to stop the program."                                          '33
MsgBox msg, vbOKOnly, ""
 
CommandButton1.Caption = "Start Measurement"                                   '36
 
End Sub
Sub perform_meas(vi As Long, ret As Long) '1
Dim pins(3) As Long 'SMU port numbers f3
pins(0) = 1 'SMU1: emitter
'pins(1) = 2 SMU2: base - open
pins(2) = 4 'SMU4: collector
ret = age5270_setSwitch(vi, pins(2), 1) '8
'ret = age5270_setSwitch(vi, pins(1), 1)
ret = age5270_setSwitch(vi, pins(0), 1)
check_err vi, ret '11
vbd_meas vi, ret, pins() '13
ret = age5270_setSwitch(vi, age5270_CH_ALL, 0) '15
check_err vi, ret
End Sub '18
Sub vbd_meas(vi As Long, ret As Long, pins() As Long) '1
Dim vstart As Double
Dim vstop As Double
Dim vb As Double
Dim ve As Double
Dim iccomp As Double
Dim ibcomp As Double
Dim iecomp As Double
Dim hold As Double
Dim delay As Double
vstart = 0
vstop = 200
vb = 0.7
ve = 0
iccomp = 0.005
ibcomp = 0.01
iecomp = 0.1
hold = 0
delay = 0 '19
Dim meas As Double '21
Dim status As Long
CommandButton1.Caption = "Measurement in progress . . ." '24
msg = "Press OK to start measurement. "
MsgBox msg, vbOKOnly, ""
ret = age5270_force(vi, pins(0), age5270_VF_MODE, 0, ve, iecomp, 0) '28
'ret = age5270_force(vi, pins(1), age5270_VF_MODE, 0, vb, ibcomp, 0)
ret = age5270_setBdv(vi, pins(2), 0, vstart, vstop, iccomp, hold, delay)
check_err vi, ret
ret = age5270_measureBdv(vi, age5270_SHORT_INTERVAL, meas, status) '32
check_err vi, ret
ret = age5270_zeroOutput(vi, age5270_CH_ALL) '34
check_err vi, ret
CommandButton1.Caption = "Measurement completed." '37
display_data meas, status, vi, ret, pins()
End Sub
Sub display_data(meas As Double, status As Long, vi As Long, ret As Long, pins() As Long) '1
Dim title As String
Dim value As String
Dim rbx As Integer
title = "Vbd Measurement Result"
If status = 8 Then 'status=8 is returned when Vbd was measured normally f6
value = "Vbd = " & meas & " (V)"
Else
value = "Vbd = " & meas & " (V)"
value = value & Chr(10) & Chr(10) & "Status value = " & status
End If
value = value & Chr(10) & Chr(10) & "Do you want to perform measurement again? "
rbx = MsgBox(value, vbYesNo + vbQuestion, title)
If rbx = vbYes Then
vbd_meas vi, ret, pins()
End If '16
End Sub

Sub check_err(vi As Long, ret As Long)
 Dim inst_err    As Long
 Dim err_message As String * 250
 Dim retStatus   As Long
 If VI_SUCCESS > ret Then
  If (age5270_INSTR_ERROR_DETECTED = ret) Then
    retStatus = age5270_error_query(vi, inst_err, err_message)
    msg = "Instrument Error:  " & inst_err & Chr(10) & Chr(10) & err_message
    MsgBox msg, vbOKOnly, ""
  Else
    retStatus = age5270_error_message(vi, ret, err_message)
    msg = "Driver Error:  " & ret & Chr(10) & Chr(10) & err_message
    MsgBox msg, vbOKOnly, ""
  End If
 End If
End Sub
