VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "Sheet1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = True
Private Sub CommandButton1_Click()                                              '1
 
Dim vi       As Long                                                            '3
Dim ret      As Long
Dim msg      As String
Dim err_msg  As String * 256                                                    '6
 
'Starting the session *******************************************
ret = age5270_init("GPIB::17::INSTR", VI_TRUE, VI_TRUE, vi)                     '9
If ((vi = VI_NULL) Or (ret < VI_SUCCESS)) Then                                 '10
  msg = "Initialization failure." & Chr(10) & Chr(10) & "Status Code:  " & ret
  MsgBox msg, vbOKOnly, ""
  If (vi <> VI_NULL) Then
    ret = age5270_error_message(vi, ret, err_msg)
    msg = "Error:  " & ret & Chr(10) & Chr(10) & err_msg
    MsgBox msg, vbOKOnly, ""
  End If
  End
End If                                                                         '19
 
ret = age5270_reset(vi)                      'Resets E5270.                    '21
ret = age5270_timeOut(vi, 60000)             'Sets time out to 60 sec.
ret = age5270_errorQueryDetect(vi, VI_TRUE)  'Enables error detection.

perform_meas vi, ret                  'Calls perform_meas subprogram.           25
'ret = age5270_cmd(vi, "aa")           'Sends invalid command.
'check_err vi, ret                     'Checks check_err subprogram operation.
 
'Closing the session ********************************************
ret = age5270_close(vi)                                                        '30
check_err vi, ret
 
msg = "Press OK to stop the program."                                          '33
MsgBox msg, vbOKOnly, ""
 
CommandButton1.Caption = "Start Measurement"                                   '36
 
End Sub
Sub perform_meas(vi As Long, ret As Long) '1
Dim m(4) As Long 'SMU port numbers f3
m(0) = 1 'SMU1: drain
m(1) = 2 'SMU2: gate
m(2) = 4 'SMU4: source
m(3) = 6 'SMU6: substrate
ret = age5270_setSwitch(vi, m(3), 1) '9
ret = age5270_setSwitch(vi, m(2), 1)
ret = age5270_setSwitch(vi, m(1), 1)
ret = age5270_setSwitch(vi, m(0), 1)
check_err vi, ret '13
sweep_meas vi, ret, m() '15
ret = age5270_setSwitch(vi, age5270_CH_ALL, 0) '17
check_err vi, ret
End Sub '20
Sub sweep_meas(vi As Long, ret As Long, m() As Long) '1
Dim vpri1 As Double '3
Dim vpri2 As Double
Dim vsyn1 As Double
Dim vsyn2 As Double
Dim vcon1 As Double
Dim vcon2 As Double
Dim i1comp As Double
Dim i2comp As Double
Dim hold As Double
Dim delay As Double
Dim s_delay As Double
Dim p1comp As Double
Dim p2comp As Double
Dim nop As Long
vpri1 = 0
vpri2 = 3
i1comp = 0.01
vsyn1 = 0
vsyn2 = 3
i2comp = 0.05
hold = 0
delay = 0
s_delay = 0
p1comp = 0
p2comp = 0
nop = 11 '28
Dim rep As Long '30
Dim sc() As Double 'primary sweep output data
Dim md() As Double 'sweep measurement data
Dim st() As Long 'status data at each step
Dim tm() As Double 'time data at each step
ReDim Preserve sc(nop) As Double
ReDim Preserve md(nop) As Double
ReDim Preserve st(nop) As Long
ReDim Preserve tm(nop) As Double '38
CommandButton1.Caption = "Measurement in progress . . ." '40
msg = "Press OK to start measurement. "
MsgBox msg, vbOKOnly, ""
ret = age5270_resetTimestamp(vi) '44
ret = age5270_force(vi, m(3), age5270_VF_MODE, 0, vcon1, 0.05, 0)
ret = age5270_force(vi, m(2), age5270_VF_MODE, 0, vcon2, 0.05, 0)
ret = age5270_setIv(vi, m(1), age5270_SWP_VF_SGLLIN, 0, vpri1, vpri2, nop, hold, delay, s_delay, i1comp, p1comp)
check_err vi, ret
ret = age5270_setSweepSync(vi, m(0), age5270_VF_MODE, 0, vsyn1, vsyn2, i2comp, p2comp)
check_err vi, ret '50
ret = age5270_sweepIv(vi, m(0), age5270_IM_MODE, 0, rep, sc(0), md(0), st(0), tm(0))
check_err vi, ret
ret = age5270_zeroOutput(vi, age5270_CH_ALL) '55
check_err vi, ret
CommandButton1.Caption = "Measurement completed." '58
If rep = nop Then '60
save_data nop, md(), st(), sc(), tm(), vi, ret, m()
Else
msg = rep & " measurement steps were returned. It must be " & nop & " steps. "
MsgBox msg, vbOKOnly, ""
End If '65
End Sub '67
Sub save_data(nop As Long, md() As Double, st() As Long, sc() As Double, tm() As Double, vi As Long, ret As Long, m() As Long) '1
Dim i As Integer 'array counter for primary sweep f3
Dim val As String 'data to be saved to a file
val = "Vg (V), Id (mA), Time (sec), Status"
For i = 0 To nop - 1 '7
val = val & Chr(13) & Chr(10) & sc(i) & "," & md(i) * 1000 & "," & tm(i) & "," & st(i)
Next i
Dim fname As String 'data file name f11
Dim fnum As Integer 'file number
fname = "data1.txt"
fnum = 1
'saves data into the file specified by fname
Open fname For Output Access Write Lock Read Write As fnum
Print #fnum, val
Close fnum
'displays data on a MsgBox
Dim title As String
Dim rbx As Integer '22
title = "Sweep Measurement Result"
val = val & Chr(10) & Chr(10) & "Data save completed."
val = val & Chr(10) & Chr(10) & "Do you want to perform measurement again? "
rbx = MsgBox(val, vbYesNo, title)
If rbx = vbYes Then
sweep_meas vi, ret, m() 'returns to sweep_meas if Yes is clicked.
End If '29
End Sub


Sub check_err(vi As Long, ret As Long)
 Dim inst_err    As Long
 Dim err_message As String * 250
 Dim retStatus   As Long
 If VI_SUCCESS > ret Then
  If (age5270_INSTR_ERROR_DETECTED = ret) Then
    retStatus = age5270_error_query(vi, inst_err, err_message)
    msg = "Instrument Error:  " & inst_err & Chr(10) & Chr(10) & err_message
    MsgBox msg, vbOKOnly, ""
  Else
    retStatus = age5270_error_message(vi, ret, err_message)
    msg = "Driver Error:  " & ret & Chr(10) & Chr(10) & err_message
    MsgBox msg, vbOKOnly, ""
  End If
 End If
End Sub
