Imports Ivi.visa.interop

Module Module1


    Sub Main()
        Dim B1500 As IResourceManager
        Dim unit1 As IMessage
        B1500 = New ResourceManager
        unit1 = B1500.Open("GPIB0::17::INSTR")
        Dim E5270 As IResourceManager
        Dim unit2 As IMessage
        E5270 = New ResourceManager
        unit2 = E5270.Open("GPIB0::22::INSTR")
        unit1.WriteString("*RST" & vbLf)
        unit2.WriteString("*RST" & vbLf)
        MsgBox("Click OK to start measurement.", vbOKOnly, "")
        Console.WriteLine("Measurement in progress. . ." & Chr(10))

        Dim t() As Integer = {1, 2, 1, 2}
        Dim term1 As String = t(0) & "," & t(1)
        Dim term2 As String = t(2) & "," & t(3)
        unit1.WriteString("CN " & term1 & vbLf)
        unit2.WriteString("CN " & term2 & vbLf)
        perform_meas(unit1, unit2, t)

        unit1.WriteString("CL" & vbLf)
        unit2.WriteString("CL" & vbLf)
        unit1.Close()
        unit2.Close()
        MsgBox("Click OK to stop the program.", vbOKOnly, "")
        Console.WriteLine("Measurement completed." & Chr(10))
    End Sub

    Sub perform_meas(ByVal unit1 As IMessage, ByVal unit2 As IMessage, ByVal t() As Integer)
        Dim i As Integer = 0                         't(0): Low1
        Dim j As Integer = 0                         't(1): High1
        Dim nop1 As Integer = 5                      't(2): High2
        Dim nop2 As Integer = 2                      't(3): Low2
        Dim data(nop2 - 1, nop1 - 1) As String
        Dim value As String = "I (mA), Time (msec), Status"
        Dim fname As String = "C:\Agilent\prog_ex\data15.txt"
        Dim title As String = "Measurement Result"
        Dim msg As String = "No error."
        Dim err As Integer = 0

        Dim v1 As Double = 0.1 : Dim v2 As Double = 0.5
        Dim vs As Double = 0 : Dim icomp As Double = 0.1
        Dim ret As Integer

        unit1.WriteString("FMT 1" & vbLf)
        unit1.WriteString("AV -1" & vbLf)
        unit1.WriteString("WT 0, 0.01" & vbLf)
        unit1.WriteString("TM 3" & vbLf)
        unit1.WriteString("TGP -1, 1, 2, 1" & vbLf)
        unit1.WriteString("TGP -2, 2, 2, 3" & vbLf)
        unit1.WriteString("TGMO 1" & vbLf)
        unit1.WriteString("DV" & t(1) & ",0," & vs & "," & icomp & vbLf)
        unit1.WriteString("WV" & t(0) & ",1,0," & v1 & "," & v2 & "," & nop1 & "," & icomp & vbLf)
        unit1.WriteString("MM 2," & t(0) & vbLf)
        unit1.WriteString("TSC 1" & vbLf)

        unit2.WriteString("FMT 1" & vbLf)
        unit2.WriteString("AV -1" & vbLf)
        unit2.WriteString("WT 0, 0.01" & vbLf)
        unit2.WriteString("TM 3" & vbLf)
        unit2.WriteString("TGP -2, 2, 2, 1" & vbLf)
        unit2.WriteString("TGXO 2" & vbLf)
        unit2.WriteString("TGP -1, 1, 2, 2" & vbLf)
        unit2.WriteString("TGSI 2" & vbLf)
        unit2.WriteString("DV" & t(3) & ",0," & vs & "," & icomp & vbLf)
        unit2.WriteString("WV" & t(2) & ",1,0," & v1 & "," & v2 & "," & nop1 & "," & icomp & vbLf)
        unit2.WriteString("MM 2," & t(2) & vbLf)
        unit2.WriteString("TSC 1" & vbLf)
        unit1.WriteString("TSR" & vbLf) : unit2.WriteString("TSR" & vbLf)
        unit2.WriteString("XE" & vbLf)

        unit1.WriteString("*OPC?" & vbLf) : ret = unit1.ReadString(1 + 2)
        unit1.WriteString("ERR? 1" & vbLf) : err = unit1.ReadString(4 + 2) : ret = 1
        If err <> 0 Then GoTo Check_err
        unit2.WriteString("ERR? 1" & vbLf) : err = unit2.ReadString(4 + 2) : ret = 2
        If err <> 0 Then GoTo Check_err


        Dim mret1 As String = unit1.ReadString(16 * 2 * nop1 + 1)
        Dim mret2 As String = unit2.ReadString(16 * 2 * nop1 + 1)
        Dim time As Double : Dim status As String : Dim meas As Double
        For i = 0 To nop1 - 1
            time = Val(Mid(mret1, 4 + i * 16 * 2, 12))
            status = Mid(mret1, 17 + i * 16 * 2, 3)
            meas = Val(Mid(mret1, 20 + i * 16 * 2, 12))
            data(0, i) = Chr(13) & Chr(10) & meas * 1000 & ", " & time * 1000 & ", " & status
        Next i
        For i = 0 To nop1 - 1
            time = Val(Mid(mret2, 4 + i * 16 * 2, 12))
            status = Mid(mret2, 17 + i * 16 * 2, 3)
            meas = Val(Mid(mret2, 20 + i * 16 * 2, 12))
            data(1, i) = Chr(13) & Chr(10) & meas * 1000 & ", " & time * 1000 & ", " & status
        Next i

        unit1.WriteString("DZ" & vbLf) : unit2.WriteString("DZ" & vbLf)
        save_data(fname, title, value, data, nop1, nop2, unit1, unit2, t)
        Exit Sub

Check_err:
        unit1.WriteString("DZ" & vbLf) : unit2.WriteString("DZ" & vbLf)
        If ret = 1 Then unit1.WriteString("EMG? " & err & vbLf) : msg = unit1.ReadString(256)
        If ret = 2 Then unit2.WriteString("EMG? " & err & vbLf) : msg = unit2.ReadString(256)
        MsgBox("Unit" & ret & " error: " & err & Chr(10) & msg, vbOKOnly, "")
        Exit Sub
    End Sub

    Sub save_data(ByVal fname As String, ByVal title As String, ByVal value As String, ByVal data(,) As String, ByVal nop1 As Integer, ByVal nop2 As Integer, ByVal unit1 As IMessage, ByVal unit2 As IMessage, ByVal t() As Integer)
        Dim i As Integer = 0
        Dim j As Integer = 0
        FileOpen(1, fname, OpenMode.Output, OpenAccess.Write, OpenShare.LockReadWrite)
        Print(1, value)
        For j = 0 To nop2 - 1
            Print(1, Chr(13) & Chr(10) & "Unit" & j + 1)
            For i = 0 To nop1 - 1
                Print(1, data(j, i))
            Next
        Next
        FileClose(1)

        Dim rbx As Integer
        For j = 0 To nop2 - 1
            value = value & Chr(10) & "Unit" & j + 1
            For i = 0 To nop1 - 1
                value = value & data(j, i)
            Next
        Next
        value = value & Chr(10) & Chr(10) & "Data save completed."
        value = value & Chr(10) & Chr(10) & "Do you want to perform measurement again?"
        rbx = MsgBox(value, vbYesNo, title)
        If rbx = vbYes Then perform_meas(unit1, unit2, t)
    End Sub

End Module
