#include <stdio.h>
#include "E5270_TIS.h"

main()
{
int ret;
#ifdef E5270_TIS_H
   ret = open_E5270( "GPIB0::17::INSTR" , ERR_DETECT_ON,NULL);
   if ( ret != 0 ) {
         printf( "E527x device open failed. Exit program.\n" );
         return( -1 );
   }
#endif

   int h_pin, l_pin;
   double v_force, comp, current; 
   v_force = 0.5;
   comp = 1e-3;
   h_pin = 12;
   l_pin = 16;

   init_system();

   connect_pin(SMU3, h_pin);
   connect_pin(GNDU, l_pin);

   force_v(h_pin, v_force, 0, comp);
   measure_i(h_pin, &current, comp);

   disable_port(h_pin);
   disconnect_all();

   printf("I = %8.6f amp (at %4.2f volt)\n", current, v_force);
   printf("R = %6.2f ohm\n", v_force / current);

#ifdef E5270_TIS_H
   close_E5270();
#endif
return( 0 );
}