#include <stdio.h>
#include "E5270_TIS.h"

main()
{
int ret;

#ifdef E5270_TIS_H
	ret = open_E5270( "GPIB0::17::INSTR" , ERR_DETECT_ON,NULL);
	if ( ret != 0 ) {
					printf( "Failed to open E5270. Exit program.\n" );
					return( -1 );
					}
#endif

int n, drain, gate, source, sub, nop, port[2], samples;
double vd, vg, ig_c, irange, vrange, icomp, current;
double meas[2], range[2], time[2];

vg = 1.5;
vd = 1.5;
vrange = 2.0;
ig_c = 1e-6;
icomp = 50e-3;
irange = 1e-9;
drain = 15;
gate = 16;
source = 17;
sub = 18;
nop =11;
n = 2;
port[0] = drain;
port[1] = gate;
range[0] = icomp;
range[1] = irange;
samples = 100;

init_system();
connect_pin(SMU1, drain);
connect_pin(SMU2, gate);
connect_pin(SMU4, source);
connect_pin(SMU6, sub);

set_timestamp(1);
set_smu_ch(0, PERCH_ADC, FILTER_OFF);
set_adc(PERCH_ADC, INTEG_MANUAL, samples, 0);

force_v(sub, 0.0, 2.0, icomp);
force_v(source, 0.0, 2.0, icomp);
force_v(gate, vg, vrange, ig_c);
reset_timestamp();
force_v(drain, vd, vrange, icomp);

int i;
char f_name[] = "data1.txt";
char head1[] = "Index, Id (mA), Time (s), Ig (pA), Time (s)";
char msg1[] = "Measurement in progress.";
char msg2[] = "Measurement and data save completed.";
char c = '\n';

FILE *stream;

if( ( stream = fopen( f_name, "w+" )) == NULL )
		printf( "Data file was not opened\n" );
	else
		printf( "%s%c", msg1, c );
		fprintf( stream, "%s%c", head1, c );
		for (i=0; i<nop;i++){
		measure_m(n, port, meas, range, time);
		fprintf(stream, "%d, %6.4f, %6.4f, %6.4f, %6.4f\n", i+1, meas[0]*1000, time[0], meas[1]*1e+12, time[1]);
		}
		printf( "%s%c", msg2, c );

if( fclose( stream ) )
	printf( "Data file was not closed\n" );


disable_port(0);
disconnect_all();

#ifdef E5270_TIS_H
	close_E5270();
#endif
	return( 0 );
}