#include <stdio.h>
#include "E5270_TIS.h"

main()
{
int ret;
#ifdef E5270_TIS_H
   ret = open_E5270( "GPIB0::17::INSTR" , ERR_DETECT_ON,NULL);
   if ( ret != 0 ) {
         printf( "E527x device open failed. Exit program.\n" );
         return( -1 );
   }
#endif

int emitter, base, collector, nop=11, n=2, port[2], samples;
double vrange, vc, iecomp, iccomp, ibcomp, vbstart, vbstop; double hold, delay, pbcomp;
double swp1[11], swp2[11], meas[22], range[2];

vrange = 20.0;
vc = 3.0;
iecomp = 0.2;
iccomp = 0.2;
ibcomp = 0.005;
vbstart = 0.5;
vbstop = 1.0;
hold = 0.0;
delay = 0.1;
pbcomp = 0.5;
samples = 200;

emitter = 12;
base = 13;
collector = 14;

init_system();
connect_pin(SMU1, emitter);
connect_pin(SMU2, base);
connect_pin(SMU4, collector);

port[0] = collector;
port[1] = base;
range[0] = 0.0;
range[1] = 0.0;

set_smu_ch(0, PERCH_ADC, FILTER_OFF);
set_adc(PERCH_ADC, INTEG_MANUAL, samples, 0);
force_v(emitter, 0.0, 2.0, iecomp);
force_v(collector, vc, vrange, iccomp);
set_iv(base, LINEAR_V, vrange, vbstart, vbstop, nop, hold, delay, ibcomp, pbcomp, COMP_STOP);

printf("Measurement in progress...\n");
sweep_miv(n, port, range, meas, swp1, swp2);

disable_port(0);
disconnect_all();

int i;
char f_name[] = "C:\Agilent\data\data1.txt";
char head1[] = " Vbe (V), Ic (mA), Ib (mA), hfe";
char msg1[] = "Saving data...";
char msg2[] = "Data save completed.";
char c = '\n';

FILE *stream;
if( ( stream = fopen( f_name, "w+" )) == NULL )
   		printf( "Data file was not opened\n" );
	else
		   printf( "%s%c", msg1, c );
		   fprintf( stream, "%s%c", head1, c );
		   for (i=0; i<nop;i++)
		   fprintf( stream, " %4.2f, %10.6f, %8.6f, %8.4f\n", swp1[i], meas[i]*1e3, meas[nop+i]*1e3, meas[i]/meas[nop+i]);
		   printf( "%s%c", msg2, c );

if( fclose( stream ) )                 
	printf( "Data file was not closed\n" );

#ifdef E5270_TIS_H
	   close_E5270();
#endif
	return( 0 );
}