#include <stdio.h>
#include "E5270_TIS.h"

main()
{
int ret;

#ifdef E5270_TIS_H
	ret = open_E5270( "GPIB0::17::INSTR" , ERR_DETECT_ON,NULL );
	if ( ret != 0 ) {
					printf( "Failed to open E5270. Exit program.\n" );
					return( -1 );
					}
#endif

int drain, gate, source, sub, nop;
double vrange1, vrange2, vd, width, period, hold, icomp, ig_c, g_p_c;
double irange, id[11], swp1[11], swp2[11];

vrange1 = 2.0;
vrange2 = 20.0;
irange = 0.0;
vd = 2.5;
nop = 11;
width = 1e-3;
period = 5e-3;
hold = 10e-3;
ig_c = 1e-3;
icomp = 50e-3;
g_p_c = 0.002;

drain = 15;
gate = 16;
source = 17;
sub = 18;

init_system();
connect_pin(SMU1, drain);
connect_pin(SMU2, gate);
connect_pin(SMU4, source);
connect_pin(SMU6, sub);

force_v(source, 0.0, vrange1, icomp);
force_v(sub, 0.0, vrange1, icomp);
set_piv(drain, LINEAR_V, vrange2, 0.0, 0.0, vd, nop, width, period, hold, icomp, COMP_STOP);
set_sync(gate, POS_SYNC, 0.0, 1.0, ig_c, g_p_c);
sweep_iv(drain, I_MEAS, irange, id, swp1, swp2);

disable_port(0);
disconnect_all();

int i;

printf(" Vg (V)  Id (mA)\n");
for (i=0; i<nop;i++)
printf(" %3.2f    %8.6f \n", swp2[i], id[i] * 1000);

#ifdef E5270_TIS_H
	close_E5270();
#endif
	return( 0 );
}